The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | Static Public Attributes | List of all members
stk::FileWrite Class Reference

STK audio file output class. More...

`#include <FileWrite.h>`

Inheritance diagram for stk::FileWrite:

## Public Member Functions
| FileWrite (void)
| Default constructor.
| FileWrite (std::string fileName, unsigned int nChannels=1, FILE_TYPE type=FILE_WAV, Stk::StkFormat format=STK_SINT16)
| Overloaded constructor used to specify a file name, type, and data format with this object.
virtual | ~FileWrite ()
| Class destructor.
void | open (std::string fileName, unsigned int nChannels=1, FileWrite::FILE_TYPE type=FILE_WAV, Stk::StkFormat format=STK_SINT16)
| Create a file of the specified type and name and output samples to it in the given data format.
void | close (void)
| If a file is open, write out samples in the queue and then close it.
bool | isOpen (void)
| Returns true if a file is currently open.
void | write (StkFrames &buffer)
| Write sample frames from the StkFrames object to the file.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Static Public Attributes
static const FILE_TYPE | FILE_RAW
static const FILE_TYPE | FILE_WAV
static const FILE_TYPE | FILE_SND
static const FILE_TYPE | FILE_AIF
static const FILE_TYPE | FILE_MAT
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK audio file output class.

This class provides output support for various audio file formats.

FileWrite writes samples to an audio file. It supports multi-channel data.

FileWrite currently supports uncompressed WAV, AIFF, AIFC, SND (AU), MAT-file (Matlab), and STK RAW file formats. Signed integer (8-, 16-, 24-, and 32-bit) and floating- point (32- and 64-bit) data types are supported. STK RAW files use 16-bit integers by definition. MAT-files will always be written as 64-bit floats. If a data type specification does not match the specified file type, the data type will automatically be modified. Compressed data types are not supported.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ FileWrite()

stk::FileWrite::FileWrite | ( | std::string | fileName,
|  | unsigned int | nChannels = 1,
|  | FILE_TYPE | type = FILE_WAV,
|  | Stk::StkFormat | format = STK_SINT16 )

Overloaded constructor used to specify a file name, type, and data format with this object.

An StkError is thrown for invalid argument values or if an error occurs when initializing the output file.

## Member Function Documentation

## ◆ open()

void stk::FileWrite::open | ( | std::string | fileName,
|  | unsigned int | nChannels = 1,
|  | FileWrite::FILE_TYPE | type = FILE_WAV,
|  | Stk::StkFormat | format = STK_SINT16 )

Create a file of the specified type and name and output samples to it in the given data format.

An StkError is thrown for invalid argument values or if an error occurs when initializing the output file.

## ◆ write()

void stk::FileWrite::write | ( | StkFrames & | buffer | ) |

Write sample frames from the StkFrames object to the file.

An StkError will be thrown if the number of channels in the StkFrames argument does not agree with the number of channels specified when opening the file.

## Member Data Documentation

## ◆ FILE_RAW

const FILE_TYPE stk::FileWrite::FILE_RAW
| static

STK RAW file type.

## ◆ FILE_WAV

const FILE_TYPE stk::FileWrite::FILE_WAV
| static

WAV file type.

## ◆ FILE_SND

const FILE_TYPE stk::FileWrite::FILE_SND
| static

SND (AU) file type.

## ◆ FILE_AIF

const FILE_TYPE stk::FileWrite::FILE_AIF
| static

AIFF file type.

## ◆ FILE_MAT

const FILE_TYPE stk::FileWrite::FILE_MAT
| static

Matlab MAT-file type.

The documentation for this class was generated from the following file:

- FileWrite.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.